#include <stdio.h>
#include <stdlib.h>


/*
* Function to create a random scenario with a specific
* number of EVs.
*/
void create_scenario(int num_ev)
{
	int num_time = 10;								// Number of time slots
	real charger_limit = 9.6;						// Charger limit
	real transformer_limit = 60.0 / 20.0 * num_ev;	// Transformer limit
	real elec_cost[10] = {0.1, 0.2, 0.4, 0.2, 0.1, 0.1, 0.2, 0.4, 0.2, 0.1};	// Electricity cost
	
	// Open the file for writing
	char filename[100];
	sprintf(filename, "scenario_random_%d.txt", num_ev);
	printf("Creating file %s\n", filename);
	FILE *file;
   	file = fopen(filename,"w");

	// Write the metadata at the top
	fprintf(file,"%d\n", num_ev);
	fprintf(file,"%d\n", num_time);
	fprintf(file,"%0.1f\n", charger_limit);
	fprintf(file,"%0.0f\n", transformer_limit);

	// Write the electricity cost
	for (int i = 0; i < num_time; i++)
		fprintf(file,"%0.1f ", elec_cost[i % 10]);
	fprintf(file,"\n");

	// Write the demand for each vehicle
	for (int i = 1; i <= num_ev; i++)
	{
		int start = 1 + rand() % (num_time - 2);
		int end = start + 1 + rand() % (num_time - start);
		int demand = INT_MAX;
		while (demand / (end - start + 1) > charger_limit)
		{
			demand = 12 + rand() % 16;	// Random integer between 12 and 28
		}
		
		fprintf(file,"%-3d  %-2d  %-2d  %-2d\n", i, start, end, demand);
	}

	// Close the file after writing
	fclose(file);
}